---
title: Computer Networks
subtitle: Internet Protocol Suite (TCP/IP)
layout: layouts/presentation.njk
---

<section>
  <section>

  <h2>What is the Internet Protocol Suite</h2>

  <p>A framework for organizing the communication protocols used in the
    Internet (and similar networks)</p>

  <p>It is commonly known as <strong>TCP/IP</strong></p>

  <p>Foundational protocols are the
    Transmission Control Protocol (<strong>TCP</strong>),
    the User Datagram Protocol (<strong>UDP</strong>),
    and the Internet Protocol (<strong>IP</strong>)</p>

  <p>
    <a href="https://datatracker.ietf.org/doc/html/rfc1122">RFC 1122</a>,
    <a href="https://datatracker.ietf.org/doc/html/rfc1123">RFC 1123</a>
  </p>
  </section>

  <section>
    <figure>
      <img src="https://upload.wikimedia.org/wikipedia/commons/c/c4/IP_stack_connections.svg"
           alt="Conceptual TCP/IP data flow">
      <figcaption>Source:
        <cite>
          <a title="en:User:Kbrose, CC BY-SA 3.0 &lt;http://creativecommons.org/licenses/by-sa/3.0/&gt;, via Wikimedia Commons"
             href="https://en.wikipedia.org/wiki/File:IP_stack_connections.svg">Wikimedia Commons</a>
        </cite>
      </figcaption>
    </figure>
  </section>

  <section>
    <figure>
      <img src="https://upload.wikimedia.org/wikipedia/commons/3/3b/UDP_encapsulation.svg"
           alt="UDP Encapsulation">
      <figcaption>Source:
        <cite>
          <a title="en:User:Cburnett original work, colorization by en:User:Kbrose, CC BY-SA 3.0 &lt;http://creativecommons.org/licenses/by-sa/3.0/&gt;, via Wikimedia Commons"
             href="https://commons.wikimedia.org/wiki/File:UDP_encapsulation.svg">Wikimedia Commons</a>
        </cite>
      </figcaption>
    </figure>
  </section>
</section>

<section>
  <h2>Link Layer</h2>
  <section>
    <p><a href="https://en.wikipedia.org/wiki/Link_layer">Lowest layer</a>
      in the Internet protocol suite</p>
    <p>The link is the network component used to interconnect hosts or nodes</p>
    <p>A link protocol is a suite of methods and standards that operate only
      between adjacent network nodes of a network segment.</p>
  </section>

  <section>
    <h3>Core Protocols</h3>
    <ul>
      <li><a href="https://en.wikipedia.org/wiki/Address_Resolution_Protocol">
        Address Resolution Protocol (ARP)</a></li>
      <li><a href="https://en.wikipedia.org/wiki/Reverse_Address_Resolution_Protocol">
        Reverse Address Resolution Protocol (RARP)</a></li>
      <li><a href="https://en.wikipedia.org/wiki/Neighbor_Discovery_Protocol">
        Neighbor Discovery Protocol (NDP)</a></li>
    </ul>
    <aside class="notes">
      <p>NDP is a facility delivering similar functionality as ARP for IPv6</p>
    </aside>
  </section>

  <section>
    <h3>Hub vs. Switch</h3>
    <dl>
      <dt>Ethernet hub, network hub, multiport repeater</dt>
      <dd>A network hardware device for connecting Ethernet devices</dd>
      <dd>Makes them act as a single network segment</dd>
      <dt>Network switch</dt>
      <dd>Multiport network bridge that uses MAC addresses to forward data</dd>
      <dd>The ports are network segments that can be bridged as individual
        pairs</dd>
    </dl>
  </section>

  <section>
    <div style="font-size: 80%;">
      {% include 'blocks/networking/mac_header.njk' %}
    </div>
    <p class="fragment">EtherType indicates which protocol is encapsulated
      in the frame</p>
    <table class="fragment">
      <tr>
        <th>EtherType</th>
        <th>Protocol</th>
      </tr>
      <tr>
        <td class="code">0x0800</td>
        <td>Internet Protocol version 4 (IPv4)</td>
      </tr>
      <tr>
        <td class="code">0x0806</td>
        <td>Address Resolution Protocol (ARP)</td>
      </tr>
      <tr>
        <td class="code">...</td>
        <td>...</td>
      </tr>
    </table>
  </section>

  <section>
    <h3>Example: ARP</h3>
    <p>Linux command-line tool <kbd>arp</kbd></p>
    <p class="fragment">Analyze ARP network traffic with Wireshark</p>

    <aside class="notes">
      <p>Define filter for ARP</p>
      <ol>
        <li><kbd>Capture &rarr; Options...</kbd></li>
        <li>Capture filter for selected interfaces: <kbd>arp</kbd></li>
      </ol>
      <p>Optionally, save the capture filter</p>
      <ol>
        <li><kbd>Capture &rarr; Capture Filters...</kbd></li>
        <li>Filter Expression: <kbd>arp</kbd></li>
      </ol>
      <p>While the packages are captures, perform a ping to a system on the
        same LAN to trigger an ARP lookup
      </p>

    </aside>
  </section>
</section>

<section>
  <h2>Internet Layer</h2>
  <section>
    <p>Group of methods, protocols, and specifications that are used to
      transport network packets from the originating host across network
      boundaries</p>
    <p>The destination host is specified by an IP address</p>
    <p><a href="https://en.wikipedia.org/wiki/Internet_layer">Internet layer</a>
      protocols use IP-based packets</p>
  </section>

  <section>
    <h3>Core Protocols</h3>
    <ul>
      <li><a href="https://en.wikipedia.org/wiki/Internet_Protocol_version_4">
        Internet Protocol version 4 (IPv4)</a></li>
      <li><a href="https://en.wikipedia.org/wiki/IPv6">
        Internet Protocol version 6 (IPv6)</a></li>
      <li><a href="https://en.wikipedia.org/wiki/Internet_Control_Message_Protocol">
        Internet Control Message Protocol</a></li>
    </ul>
    <aside class="notes">
      <p>NDP is a facility delivering similar functionality as ARP for IPv6</p>
    </aside>
  </section>

  <section>
    <div style="font-size: 40%;">
      {% include 'blocks/networking/ipv4_packet.njk' %}
    </div>
  </section>

  <section>
    <h3>Internet Control Message Protocol (ICMP)</h3>
    <div style="font-size: 40%;">
      {% include 'blocks/networking/icmp_header.njk' %}
    </div>
    <div class="fragment">
    <p>The most common ICMP "user" application is <code>ping</code></p>
{% highlight "shell" %}
ping ${HOST_OR_IP}
{% endhighlight %}
    </div>
  </section>

  <section>
    <h3>Example</h3>
    <p>Investigate IPv4 packet with Wireshark</p>
    <p class="fragment">Investigate ICMPv4 datagram with Wireshark</p>
  </section>


</section>

<section>
  <h2>Transport Layer</h2>
  <section>
    <p>The protocols of the
      <a href="https://en.wikipedia.org/wiki/Transport_layer">transport
        layer</a> provide end-to-end communication services
      for applications.</p>
    <p>They provide services such as connection-oriented
      communication, reliability and flow and congestion control.</p>
  </section>

  <section>
    <h3>Core Protocols</h3>
    <ul>
      <li><a href="https://en.wikipedia.org/wiki/Transmission_Control_Protocol">
        Transmission Control Protocol (TCP)</a></li>
      <li><a href="https://en.wikipedia.org/wiki/User_Datagram_Protocol">
        User Datagram Protocol (UDP)</a><br />
        used by (eg.) DNS and DHCP</li>
      <li><a href="https://en.wikipedia.org/wiki/QUIC"
             title="improves performance over TCP">QUIC</a></li>
    </ul>
    <aside class="notes">
      <ul>
        <li>QUIC improves performance of connection-oriented web applications
          that are currently using TCP</li>
        <li>HTTP/3, QUIC is used as a transport instead of TCP</li>
        <li>QUIC is designed to obsolete TCP for many applications, earning the
        protocol the occasional nickname "TCP/2"</li>
      </ul>
    </aside>
  </section>

  <section>
    <h3>Ports</h3>
    <p>TCP and UDP use port numbers to identify sending and receiving
      application end-points on a host.</p>
    <p>Ports are often called Internet sockets.</p>
    <ul>
      <li>Port numbers are 16-bit unsigned integers</li>
      <li class="fragment">Ports 0-1023 are
        <a href="https://en.wikipedia.org/wiki/List_of_TCP_and_UDP_port_numbers#Well-known_ports">
        <em>well-known ports</em> or
        <em>system ports</em>
        </a>
      </li>
      <li class="fragment">Examples: SSH, SMTP, HTTP, HTTPS, POP3, IMAP, ...</li>
    </ul>

    <aside class="notes">
      <ul>
        <li>$2^{16}$ = 65536 (port numbers 0 to 65535)</li>
        <li>$2^{10}$ system ports (numbers 0 to 1023)</li>
        <li>SMTP (Simple Mail Transfer Protocol): 25, SMTPS: 465</li>
        <li>POP3 (Post Office Protocol): 110, POP3S: 995</li>
        <li>IMAP (Internet Message Access Protocol): 143, IMAPS: 993</li>
      </ul>
    </aside>
  </section>

  <section>
    <div style="font-size: 40%;">
    {% include 'blocks/networking/tcp_header.njk' %}
    </div>
  </section>

  {# TODO  add
  <section>
    <h3>UDP datagram structure</h3>
  </section>#}

  <section>
    <h3>Example</h3>
    <p>Investigate TCP  with Wireshark</p>

    <aside class="notes">
      <p>Filter for <code>host sandbox.bulme.at</code> and have students
        identify the source port and destination port of their connection.</p>
      <p>Discuss system ports: first 6 bits are always 0. First hex char has
        to be 0; second can be up to 3. Client ports are in the dynamic port
        range (no extra privileges needed).</p>
    </aside>
  </section>

</section>

<section>
  <h2>Application Layer</h2>
  <section>
    <p><a href="https://en.wikipedia.org/wiki/Application_layer">
      Application layer</a> protocols provide process-to-process
      communications across an Internet Protocol (IP) computer network.</p>

    <ul>
      <li>Depends on the underlying transport layer</li>
    </ul>
  </section>

  <section>
    <h3>Robustness Principle (Postel's Law)</h3>
    <p>Software design guideline that states:<br />
      <q>Be conservative in what you do, be liberal in what you accept
        from others</q></p>
    <p>Reworded as
      <figure>
      <blockquote>
        "Be liberal in what you accept, and conservative in what you send"
      </blockquote>
      <figcaption><cite>Jon Postel,
        <a href="https://datatracker.ietf.org/doc/html/rfc1123">RFC 1123</a>
        </cite>
      </figcaption>
      </figure>
    </p>

    <aside class="notes">
      <p>The <a href="https://en.wikipedia.org/wiki/Robustness_principle">
        Robustness principle
      </a> is named after Jon Postel. He used the wording in an early
        specification of TCP.</p>
      <p>Example: HTTP headers; related example: HTML (Browsers accept almost
        anything)
      </p>
      <p>Criticism for adverse effects (lack of robustness). Martin Thomson:
        "A flaw can become entrenched as a de facto standard. Any
        implementation of the protocol is required to replicate the aberrant
        behavior, or it is not interoperable."
      </p>
      <p>Example: Internet Explorer ended up in being a desaster for the
        web (quirks mode)</p>
    </aside>
  </section>

  <section>
    <h3>Prominent Protocols</h3>
    <ul>
      <li><a href="https://en.wikipedia.org/wiki/Hypertext_Transfer_Protocol">
        Hypertext Transfer Protocol (HTTP :80, HTTP :443)</a></li>
      <li>
        <a href="https://en.wikipedia.org/wiki/Telnet">
          Telnet (:23)</a>,
        <a href="https://en.wikipedia.org/wiki/Secure_Shell">
          Secure Shell (SSH :22)</a>,<br />
        <a href="https://en.wikipedia.org/wiki/SSH_File_Transfer_Protocol">
        SSH File Transfer Protocol (SFTP :22)</a>
      </li>
      <li>
        <a href="https://en.wikipedia.org/wiki/File_Transfer_Protocol">
          File Transfer Protocol (FTP :20 + :21, FTPS :989 + :990)</a>,<br />
        <a href="https://en.wikipedia.org/wiki/Trivial_File_Transfer_Protocol">
          Trivial File Transfer Protocol (TFTP :69)</a>
        </li>
      <li><a href="https://en.wikipedia.org/wiki/Simple_Mail_Transfer_Protocol">
        Simple Mail Transfer Protocol (SMTP :25, SMTPS :587 or :465)</a></li>
      <li><a href="https://en.wikipedia.org/wiki/Domain_Name_System">
         Domain Name System (DNS :53)</a></li>
      <li>...</li>
    </ul>
    <aside class="notes">
      <p>Why are there so many (prominent) protocols in this layer?</p>
    </aside>
  </section>

  <section>
    <h3>Example</h3>
    <p>Investigate HTTP with Wireshark</p>

    <aside class="notes">
      <ol>
        <li>Capture filter for
          <code>host wireshark.bulme.at and port http</code></li>
        <li>Access <a href="http://wireshark.bulme.at/login/">
          <kbd>http://wireshark.bulme.at/login/</kbd></a></li>
        <li>View filter for <code>http</code></li>
        <li>Inspect compressed data</li>
        <li>Find out the username and password sent over the wire</li>
      </ol>
    </aside>
  </section>

</section>





{% include 'slides/closing.njk' %}
